require 'll/wk/api/connection'
module LL
  module WK
    # API Functionality for clients of the WebKiosk
    module API
      RUN_BENCHMARKS = true

      module_function

      attr_writer :logger

      def logger
        @logger ||= Logger.new(STDERR)
      end

      def connect(url:, email:, password:)
        API::Connection.factory(url: url, email: email, password: password)
      end

      def benchmark(name = nil)
        return yield unless RUN_BENCHMARKS
        require 'benchmark'
        logger.debug("Execution of block #{name} commencing at #{Time.now}")
        res = nil
        time = Benchmark.measure do
          res = yield
        end
        readable = Time.at(time.real).strftime('%Mm, %S.%Ls')
        logger.debug("Execution of block #{name} complete at #{Time.now}. Executed in: {#{readable}}")
        res
      end
    end
  end
end
